## apparmor 2.7.0~beta1+bzr1774

=== Makefile ===
#
#
OVERRIDE_TARBALL=yes

include common/Make.rules

DIRS=parser \
     profiles \
     utils \
     changehat/libapparmor \
     changehat/mod_apparmor \
     changehat/pam_apparmor \
     tests

REPO_URL?=lp:apparmor
# alternate possibilities to export from
#REPO_URL=.
#REPO_URL="bzr+ssh://bazaar.launchpad.net/~sbeattie/+junk/apparmor-dev/"

RELEASE_DIR=apparmor-${VERSION}
__SETUP_DIR?=.

# We create a separate version for tags because git can't handle tags
# with embedded ~s in them. No spaces around '-' or they'll get
# embedded in ${VERSION}
TAG_VERSION=$(subst ~,-, ${VERSION})

.PHONY: tarball
tarball: clean
	REPO_VERSION=`$(value REPO_VERSION_CMD)` ; \
	make export_dir __EXPORT_DIR=${RELEASE_DIR} __REPO_VERSION=$${REPO_VERSION} ; \
	make setup __SETUP_DIR=${RELEASE_DIR} ; \
	tar --exclude deprecated -cvzf ${RELEASE_DIR}.tar.gz ${RELEASE_DIR}

.PHONY: snapshot
snapshot: clean
	REPO_VERSION=`$(value REPO_VERSION_CMD)` ; \
	SNAPSHOT_DIR=apparmor-${VERSION}~$${REPO_VERSION} ;\
	make export_dir __EXPORT_DIR=$${SNAPSHOT_DIR} __REPO_VERSION=$${REPO_VERSION} ; \
	make setup __SETUP_DIR=$${SNAPSHOT_DIR} ; \
	tar --exclude deprecated -cvzf $${SNAPSHOT_DIR}.tar.gz $${SNAPSHOT_DIR} ;


.PHONY: export_dir
export_dir:
	mkdir $(__EXPORT_DIR)
	/usr/bin/bzr export --per-file-timestamps -r $(__REPO_VERSION) $(__EXPORT_DIR) $(REPO_URL)
	echo "$(REPO_URL) $(__REPO_VERSION)" > $(__EXPORT_DIR)/common/.stamp_rev

.PHONY: clean
clean:
	-rm -rf ${RELEASE_DIR} ./apparmor-${VERSION}~*
	for dir in $(DIRS); do \
		make -C $$dir clean; \
	done

.PHONY: setup
setup:
	cd $(__SETUP_DIR)/libraries/libapparmor && ./autogen.sh

.PHONY: tag
tag:
	bzr tag apparmor_${TAG_VERSION}

=== parser/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 1999, 2000, 2001, 2002, 2004, 2005, 2006, 2007
#    NOVELL (All rights reserved)
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME=apparmor-parser
all:
COMMONDIR=../common/

include common/Make.rules

COMMONDIR_EXISTS=$(strip $(shell [ -d ${COMMONDIR} ] && echo true))
ifeq ($(COMMONDIR_EXISTS), true)
common/Make.rules: $(COMMONDIR)/Make.rules
	ln -sf $(COMMONDIR) .
endif

DESTDIR=/
APPARMOR_BIN_PREFIX=${DESTDIR}/lib/apparmor
CONFDIR=/etc/apparmor
INSTALL_CONFDIR=${DESTDIR}${CONFDIR}
LOCALEDIR=/usr/share/locale
MANPAGES=apparmor.d.5 apparmor.7 apparmor_parser.8 subdomain.conf.5 apparmor.vim.5

YACC	:= /usr/bin/bison
YFLAGS	:= -d
LEX	:= /usr/bin/flex
LEXFLAGS = -B -v
WARNINGS = -Wall
EXTRA_WARNINGS = -Wsign-compare -Wmissing-field-initializers -Wformat-security -Wunused-parameter
CXX_WARNINGS = ${WARNINGS} $(shell for warning in ${EXTRA_WARNINGS} ; do \
			if ${CC} $${warning} -S -o /dev/null -xc /dev/null >/dev/null 2>&1; then \
				echo "$${warning}"; \
			fi ; \
		done)
CPP_WARNINGS = -Wstrict-prototypes -Wnested-externs
ifndef CFLAGS
CFLAGS	= -g -O2 -pipe

ifdef DEBUG
CFLAGS += -pg
endif
endif #CFLAGS

EXTRA_CXXFLAGS = ${CFLAGS} ${CXX_WARNINGS} -D_GNU_SOURCE
EXTRA_CFLAGS = ${EXTRA_CXXFLAGS} ${CPP_WARNINGS}

#LEXLIB	:= -lfl

# override this on the make command to point to where the immunix.h file is
# (yeah this is lame, but since we are tied to the kernel so tightly...)
#INCLUDEDIR = /usr/src/linux/include
INCLUDEDIR =

ifdef INCLUDEDIR
	CFLAGS += -I$(INCLUDEDIR)
endif

# Internationalization support. Define a package and a LOCALEDIR
EXTRA_CFLAGS+=-DPACKAGE=\"${NAME}\" -DLOCALEDIR=\"${LOCALEDIR}\"

# Compile-time configuration of the location of the config file
EXTRA_CFLAGS+=-DSUBDOMAIN_CONFDIR=\"${CONFDIR}\"

SRCS = parser_common.c parser_include.c parser_interface.c parser_lex.c \
       parser_main.c parser_misc.c parser_merge.c parser_symtab.c \
       parser_yacc.c parser_regex.c parser_variable.c parser_policy.c \
       parser_alias.c
HDRS = parser.h parser_include.h immunix.h
TOOLS = apparmor_parser

OBJECTS = $(SRCS:.c=.o)

AAREDIR= libapparmor_re
AAREOBJECT = ${AAREDIR}/libapparmor_re.a
AAREOBJECTS = $(AAREOBJECT) libstdc++.a
AARE_LDFLAGS=-static-libgcc -L.

LEX_C_FILES	= parser_lex.c
YACC_C_FILES	= parser_yacc.c parser_yacc.h

TESTS = tst_regex tst_misc tst_symtab tst_variable
TEST_CFLAGS = $(EXTRA_CFLAGS) -DUNIT_TEST -Wno-unused-result
TEST_OBJECTS = $(filter-out \
			parser_lex.o \
			parser_yacc.o \
			parser_main.o, ${OBJECTS}) \
               $(AAREOBJECTS)
TEST_LDFLAGS = $(AARE_LDFLAGS)

ifdef V
  VERBOSE = 1
endif
ifndef VERBOSE
  VERBOSE = 0
endif
ifeq ($(VERBOSE),1)
  BUILD_OUTPUT =
  Q =
else
  BUILD_OUTPUT = > /dev/null 2>&1
  Q = @
endif
export Q VERBOSE BUILD_OUTPUT

po/${NAME}.pot: ${SRCS} ${HDRS}
	make -C po ${NAME}.pot NAME=${NAME} SOURCES="${SRCS} ${HDRS}"

techdoc.pdf: techdoc.tex
	while pdflatex $< ${BUILD_OUTPUT} || exit 1 ; \
		grep -q "Label(s) may have changed" techdoc.log; \
	do :; done

techdoc/index.html: techdoc.pdf
	latex2html -show_section_numbers -split 0 -noinfo -nonavigation -noaddress techdoc.tex ${BUILD_OUTPUT}

techdoc.txt: techdoc/index.html
	w3m -dump $< > $@

# targets arranged this way so that people who don't want full docs can
# pick specific targets they want.
arch: 	$(TOOLS)

manpages:	$(MANPAGES)

htmlmanpages:	$(HTMLMANPAGES)

pdf:	techdoc.pdf

docs:	manpages htmlmanpages pdf

indep: docs
	$(Q)make -C po all

all:	arch indep


.PHONY: libstdc++.a
libstdc++.a:
	rm -f ./libstdc++.a
	ln -s `g++ -print-file-name=libstdc++.a`

apparmor_parser: $(OBJECTS) $(AAREOBJECTS)
	g++ $(EXTRA_CFLAGS) -o $@ $(OBJECTS) $(LIBS) \
	      ${LEXLIB}  $(AAREOBJECTS) $(AARE_LDFLAGS)

parser_yacc.c parser_yacc.h: parser_yacc.y parser.h
	$(YACC) $(YFLAGS) -o parser_yacc.c parser_yacc.y

parser_lex.c: parser_lex.l parser_yacc.h parser.h
	$(LEX) ${LEXFLAGS} -o$@ $<

parser_lex.o: parser_lex.c parser.h parser_yacc.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_misc.o: parser_misc.c parser.h parser_yacc.h af_names.h cap_names.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_yacc.o: parser_yacc.c parser_yacc.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_main.o: parser_main.c parser.h parser_version.h libapparmor_re/apparmor_re.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_interface.o: parser_interface.c parser.h libapparmor_re/apparmor_re.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_include.o: parser_include.c parser.h parser_include.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_merge.o: parser_merge.c parser.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_regex.o: parser_regex.c parser.h libapparmor_re/apparmor_re.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_symtab.o: parser_symtab.c parser.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_variable.o: parser_variable.c parser.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_policy.o: parser_policy.c parser.h parser_yacc.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_alias.o: parser_alias.c parser.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_common.o: parser_common.c parser.h
	$(CC) $(EXTRA_CFLAGS) -c -o $@ $<

parser_version.h: Makefile
	@echo \#define PARSER_VERSION \"$(VERSION)\" > .ver
	@mv -f .ver $@

# These are the families that it doesn't make sense for apparmor to mediate.
# We use PF_ here since that is what is required in bits/socket.h, but we will
# rewrite these as AF_.
FILTER_FAMILIES=PF_MAX PF_UNSPEC PF_UNIX PF_LOCAL PF_NETLINK


__FILTER=$(shell echo $(strip $(FILTER_FAMILIES)) | sed -e 's/ /\\\|/g')

af_names.h: /usr/include/bits/socket.h
	LC_ALL=C sed -n -e '/$(__FILTER)/d' -e "s/^\#define[ \\t]\\+PF_\\([A-Z0-9_]\\+\\)[ \\t]\\+\\([0-9]\\+\\)\\(.*\\)\$$/#ifndef AF_\\1\\n#  define AF_\\1 \\2\\n#endif\\nAA_GEN_NET_ENT(\"\\L\\1\", \\UAF_\\1)\\n/p" $< > $@
	LC_ALL=C sed -n -e "s/^\#define[ \\t]\\+PF_MAX[ \\t]\\+\\([0-9]\\+\\)[ \\t]\\+.*/#define AA_AF_MAX \\1\n/p" $< >> $@
	# cat $@

cap_names.h: /usr/include/linux/capability.h
	LC_ALL=C sed -n -e "/CAP_EMPTY_SET/d" -e "s/^\#define[ \\t]\\+CAP_\\([A-Z0-9_]\\+\\)[ \\t]\\+\\([0-9xa-f]\\+\\)\\(.*\\)\$$/\{\"\\L\\1\", \\UCAP_\\1\},/p" $< > $@

tst_%: parser_%.c parser.h $(filter-out parser_%.o, ${TEST_OBJECTS})
	$(CC) $(TEST_CFLAGS) -o $@ $< $(filter-out $(<:.c=.o), ${TEST_OBJECTS}) $(TEST_LDFLAGS)

.SILENT: check
.PHONY: check
check: tests

.SILENT: tests
tests: apparmor_parser ${TESTS}
	sh -e -c 'for test in ${TESTS} ; do echo "*** running $${test}" && ./$${test}; done'
	$(Q)make -s -C tst tests

# always need to rebuild.
.SILENT: $(AAREOBJECT)
.PHONY: $(AAREOBJECT)
$(AAREOBJECT):
	make -C $(AAREDIR) CFLAGS="$(EXTRA_CXXFLAGS)"

.PHONY: install-rhel4
install-rhel4: install-redhat

.PHONY: install-redhat
install-redhat:
	install -m 755 -d $(DESTDIR)/etc/init.d
	install -m 755 rc.apparmor.$(subst install-,,$@) $(DESTDIR)/etc/init.d/apparmor
	install -m 755 rc.aaeventd.redhat $(DESTDIR)/etc/init.d/aaeventd

.PHONY: install-suse
install-suse:
	install -m 755 -d $(DESTDIR)/etc/init.d
	install -m 755 rc.apparmor.$(subst install-,,$(@)) $(DESTDIR)/etc/init.d/boot.apparmor
	install -m 755 rc.aaeventd.$(subst install-,,$(@)) $(DESTDIR)/etc/init.d/aaeventd
	install -m 755 -d $(DESTDIR)/sbin
	ln -sf /etc/init.d/boot.apparmor $(DESTDIR)/sbin/rcapparmor
	ln -sf rcapparmor $(DESTDIR)/sbin/rcsubdomain
	ln -sf /etc/init.d/aaeventd $(DESTDIR)/sbin/rcaaeventd

.PHONY: install-slackware
install-slackware:
	install -m 755 -d $(APPARMOR_BIN_PREFIX)/install
	install -m 755 frob_slack_rc $(APPARMOR_BIN_PREFIX)/install
	install -m 755 -d $(DESTDIR)/etc/rc.d
	install -m 755 rc.apparmor.$(subst install-,,$(@)) $(DESTDIR)/etc/rc.d/rc.apparmor

.PHONY: install-debian
install-debian:

.PHONY: install-unknown
install-unknown:

INSTALLDEPS=arch
ifdef DISTRO
INSTALLDEPS+=install-$(DISTRO)
endif

.PHONY: install
install: install-indep install-arch

.PHONY: install-arch
install-arch: $(INSTALLDEPS)
	install -m 755 -d $(DESTDIR)/sbin
	install -m 755 ${TOOLS} $(DESTDIR)/sbin

.PHONY: install-indep
install-indep:
	install -m 755 -d $(INSTALL_CONFDIR)
	install -m 644 subdomain.conf $(INSTALL_CONFDIR)
	install -m 755 -d ${DESTDIR}/var/lib/apparmor
	install -m 755 -d $(APPARMOR_BIN_PREFIX)
	install -m 755 rc.apparmor.functions $(APPARMOR_BIN_PREFIX)
	make -C po install NAME=${NAME} DESTDIR=${DESTDIR}
	make install_manpages DESTDIR=${DESTDIR}

.SILENT: clean
.PHONY: clean
clean: _clean
	rm -f core core.* *.o *.s *.a *~
	rm -f $(TOOLS) $(TESTS)
	rm -f $(LEX_C_FILES)
	rm -f $(YACC_C_FILES)
	rm -f parser_version.h
	rm -f $(NAME)*.tar.gz $(NAME)*.tgz
	rm -f af_names.h
	rm -f cap_names.h
	rm -rf techdoc.aux techdoc.log techdoc.pdf techdoc.toc techdor.txt techdoc/
	make -s -C $(AAREDIR) clean
	make -s -C po clean
	make -s -C tst clean

.SILENT: dist_clean
dist_clean:
	@make clean
	@rm -f $(LEX_C_FILES) $(YACC_C_FILES)

=== profiles/Makefile ===
# ------------------------------------------------------------------
#
#    Copyright (C) 2002-2009 Novell/SUSE
#    Copyright (C) 2010 Canonical Ltd.
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
#
# ------------------------------------------------------------------

# Makefile for LSM-based AppArmor profiles

NAME=apparmor-profiles
ALL: local
COMMONDIR=../common/

include common/Make.rules

COMMONDIR_EXISTS=$(strip $(shell [ -d ${COMMONDIR} ] && echo true))
ifeq ($(COMMONDIR_EXISTS), true)
common/Make.rules: $(COMMONDIR)/Make.rules
	ln -sf $(COMMONDIR) .
endif

DESTDIR=/
PROFILES_DEST=${DESTDIR}/etc/apparmor.d
EXTRAS_DEST=${DESTDIR}/etc/apparmor/profiles/extras/
PROFILES_SOURCE=./apparmor.d
EXTRAS_SOURCE=./apparmor/profiles/extras/
SUBDIRS_MUST_BE_SKIPPED=${PROFILES_SOURCE}/abstractions ${PROFILES_SOURCE}/apache2.d ${PROFILES_SOURCE}/program-chunks ${PROFILES_SOURCE}/tunables ${PROFILES_SOURCE}/local
PROFILES_TO_COPY=$(filter-out ${SUBDIRS_MUST_BE_SKIPPED}, $(wildcard ${PROFILES_SOURCE}/*))
TUNABLES_TO_COPY=$(filter-out ${PROFILES_SOURCE}/tunables/home.d ${PROFILES_SOURCE}/tunables/multiarch.d, $(wildcard ${PROFILES_SOURCE}/tunables/*))
ABSTRACTIONS_TO_COPY=$(filter-out ${PROFILES_SOURCE}/abstractions/ubuntu-browsers.d, $(wildcard ${PROFILES_SOURCE}/abstractions/*))

local:
	for profile in ${PROFILES_TO_COPY}; do \
		fn=$$(basename $$profile); \
		echo "# Site-specific additions and overrides for '$$fn'" > ${PROFILES_SOURCE}/local/$$fn; \
	done; \

.PHONY: install
install: local
	install -m 755 -d ${PROFILES_DEST}
	install -m 755 -d ${PROFILES_DEST}/abstractions \
                          ${PROFILES_DEST}/apache2.d \
                          ${PROFILES_DEST}/program-chunks \
                          ${PROFILES_DEST}/tunables \
                          ${PROFILES_DEST}/tunables/home.d \
                          ${PROFILES_DEST}/local
	install -m 644 ${PROFILES_TO_COPY} ${PROFILES_DEST}
	install -m 644 ${ABSTRACTIONS_TO_COPY} ${PROFILES_DEST}/abstractions
	install -m 755 -d ${PROFILES_DEST}/abstractions/ubuntu-browsers.d
	install -m 644 ${PROFILES_SOURCE}/abstractions/ubuntu-browsers.d/* ${PROFILES_DEST}/abstractions/ubuntu-browsers.d
	install -m 644 ${PROFILES_SOURCE}/apache2.d/* ${PROFILES_DEST}/apache2.d
	install -m 644 ${PROFILES_SOURCE}/program-chunks/* ${PROFILES_DEST}/program-chunks
	install -m 644 ${TUNABLES_TO_COPY} ${PROFILES_DEST}/tunables
	install -m 644 ${PROFILES_SOURCE}/tunables/home.d/* ${PROFILES_DEST}/tunables/home.d
	install -m 644 ${PROFILES_SOURCE}/tunables/multiarch.d/* ${PROFILES_DEST}/tunables/multiarch.d
	install -m 755 -d ${EXTRAS_DEST}
	install -m 644 ${EXTRAS_SOURCE}/* ${EXTRAS_DEST}
	install -m 644 ${PROFILES_SOURCE}/local/* ${PROFILES_DEST}/local

LOCAL_ADDITIONS=$(filter-out ${PROFILES_SOURCE}/local/README, $(wildcard ${PROFILES_SOURCE}/local/*))
.PHONY: clean
clean:
	-rm -f $(NAME)-$(VERSION)*.tar.gz Make.rules ${LOCAL_ADDITIONS}

ifndef VERBOSE
  Q=@
else
  Q=
endif

ifndef PARSER
# use system parser
PARSER=../parser/apparmor_parser
endif

ifndef LOGPROF
# use ../utils logprof
LOGPROF=perl -I../utils/ ../utils/aa-logprof
endif

IGNORE_FILES=${EXTRAS_SOURCE}/README
CHECK_PROFILES=$(filter-out ${IGNORE_FILES} ${SUBDIRS_MUST_BE_SKIPPED}, $(wildcard ${PROFILES_SOURCE}/*) $(wildcard ${EXTRAS_SOURCE}/*))

.PHONY: check
check:
	@echo "*** Checking profiles from ${PROFILES_SOURCE} and ${EXTRAS_SOURCE} against apparmor_parser"
	$(Q)for profile in ${CHECK_PROFILES} ; do \
		${PARSER} -S -b ${PWD}/apparmor.d $${profile} > /dev/null || exit 1; \
	done
	@echo "*** Checking profiles from ${PROFILES_SOURCE} against logprof"
	$(Q)${LOGPROF} -d ${PROFILES_SOURCE} -f /dev/null || exit 1

=== utils/Makefile ===
# ----------------------------------------------------------------------
#    Copyright (c) 1999, 2004-2009 NOVELL (All rights reserved)
#    Copyright (c) 2010-2011 Canonical Ltd.
#
#    This program is free software; you can redistribute it and/or
#    modify it under the terms of version 2 of the GNU General Public
#    License published by the Free Software Foundation.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, contact Novell, Inc.
# ----------------------------------------------------------------------
NAME 		= apparmor-utils
all:
COMMONDIR=../common/

include common/Make.rules

COMMONDIR_EXISTS=$(strip $(shell [ -d ${COMMONDIR} ] && echo true))
ifeq ($(COMMONDIR_EXISTS), true)
common/Make.rules: $(COMMONDIR)/Make.rules
	ln -sf $(COMMONDIR) .
endif

MODDIR = Immunix
PERLTOOLS = aa-genprof aa-logprof aa-autodep aa-audit aa-complain aa-enforce \
	aa-unconfined aa-notify aa-disable
TOOLS = ${PERLTOOLS} aa-decode aa-status
MODULES = ${MODDIR}/AppArmor.pm ${MODDIR}/Repository.pm \
	${MODDIR}/Config.pm ${MODDIR}/Severity.pm

MANPAGES = ${TOOLS:=.8} logprof.conf.5

all: ${MANPAGES} ${HTMLMANPAGES}
	make -C po all

# need some better way of determining this
DESTDIR=/
BINDIR=${DESTDIR}/usr/sbin
CONFDIR=${DESTDIR}/etc/apparmor
VENDOR_PERL?=/usr/lib/perl5/vendor_perl
PERLDIR=${DESTDIR}${VENDOR_PERL}/${MODDIR}

po/${NAME}.pot: ${TOOLS}
	make -C po ${NAME}.pot NAME=${NAME} SOURCES="${TOOLS} ${MODULES}"

.PHONY: install
install: ${MANPAGES} ${HTMLMANPAGES}
	install -d ${CONFDIR}
	install -m 644 logprof.conf severity.db notify.conf ${CONFDIR}
	install -d ${BINDIR}
	ln -sf aa-status ${BINDIR}/apparmor_status
	install -m 755 ${TOOLS} ${BINDIR}
	install -d ${PERLDIR}
	install -m 755 ${MODULES} ${PERLDIR}
	make -C po install DESTDIR=${DESTDIR} NAME=${NAME}
	make install_manpages DESTDIR=${DESTDIR}
	ln -sf aa-status.8 ${DESTDIR}/${MANDIR}/man8/apparmor_status.8

.PHONY: clean
.SILENT: clean
clean: _clean
	rm -f core core.* *.o *.s *.a *~
	rm -f Make.rules
	make -C po clean

check:
	for i in ${MODULES} ${PERLTOOLS} ; do \
		perl -c $$i || exit 1; \
	done

=== parser/libapparmor_re/Makefile ===
# Profiling:
#EXTRA_CFLAGS = -pg

TARGET=libapparmor_re.a

CFLAGS ?= -g -Wall -O2 ${EXTRA_CFLAGS}
CXXFLAGS := ${CFLAGS}

ARFLAGS=-rcs

BISON := bison

all : ${TARGET}

libapparmor_re.a: parse.o expr-tree.o hfa.o compressed_hfa.o aare_rules.o
	ar ${ARFLAGS} $@ $^

expr-tree.o: expr-tree.cc expr-tree.h

hfa.o: hfa.cc apparmor_re.h hfa.h ../immunix.h

aare_rules.o: aare_rules.cc aare_rules.h apparmor_re.h expr-tree.h hfa.h compressed_hfa.h parse.h ../immunix.h

compressed_hfa.o: compressed_hfa.cc compressed_hfa.h ../immunix.h

parse.o : parse.cc apparmor_re.h expr-tree.h

parse.cc : parse.y parse.h flex-tables.h ../immunix.h
	${BISON} -o $@ $<

clean:
	rm -f *.o parse.cc ${TARGET}

=== utils/vim/Makefile ===
apparmor.vim: apparmor.vim.in Makefile create-apparmor.vim.sh
	sh create-apparmor.vim.sh

=== debian/changelog ===
apparmor (2.7.0~beta1+bzr1774-1) unstable; urgency=low

  * New upstream devel snapshot:
    - drop 0002-lp750381.patch, taken upstream.
    - drop 0004-lp754889.patch, taken upstream.
    - drop 0005-lp761217.patch, taken upstream.
    - drop 0100-manpage-typo.patch, taken upstream.
    - drop 0101-declarations.patch, solved differently upstream.
    - drop 0102-manpage-release-name.patch, taken upstream.
    - drop 0103-kfreebsd-compile.patch, taken upstream.
    - drop define-path-max.patch, taken upstream.
    - drop indep-build.patch, taken upstream.
    - debian/libapparmor1.manpages: add new function man pages.
  * Merge with Ubuntu:
    - drop 0104-python-aa-status.patch, taken upstream.
    - drop 0105-lightdm.patch, taken upstream.
    - drop 0106-lp810270.patch, taken upstream.
    - drop 0107-lp767308.patch, taken upstream.
    - drop 0108-gnome-mimeinfo.patch, taken upstream.
    - drop 0109-add-profile-repo-info.patch, taken upstream.
  * Add af_names-generation.patch to allow arbitrary socket.h file location.

 -- Kees Cook <kees@debian.org>  Wed, 10 Aug 2011 18:12:34 -0700

apparmor (2.6.1-4ubuntu5) oneiric; urgency=low

  * debian/patches/0109-add-profile-repo-info.patch: add a blurb about the
    new profiles repository to aa-genprof, along with a link to the wiki
    page.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 18 Jul 2011 10:49:13 -0400

apparmor (2.6.1-4ubuntu4) oneiric; urgency=low

  * debian/patches/0106-lp810270.patch: updated to use upstream commits

 -- Jamie Strandboge <jamie@ubuntu.com>  Fri, 15 Jul 2011 14:08:38 -0500

apparmor (2.6.1-4ubuntu3) oneiric; urgency=low

  * debian/patches/0106-lp810270.patch: adjustments for /var/run -> /run,
    /var/lock -> /run/lock and /dev/shm -> /run/shm transition (LP: #810270)
  * debian/patches/0107-lp767308.patch: allow read access to
    /usr/local/share/ca-certificates (LP: #767308)
  * debian/patches/0001-add-chromium-browser.patch: updates for newer chromium
    (LP: #776648)
  * debian/patches/0108-gnome-mimeinfo.patch: allow read access to
    /usr/share/gnome/applications/mimeinfo.cache in the gnome abstraction

 -- Jamie Strandboge <jamie@ubuntu.com>  Thu, 14 Jul 2011 09:39:49 -0500

apparmor (2.6.1-4ubuntu2) oneiric; urgency=low

  * debian/patches/0105-lightdm.patch: allow owner read access to
    /var/run/lightdm/authority/[0-9]*

 -- Jamie Strandboge <jamie@ubuntu.com>  Wed, 22 Jun 2011 16:29:11 -0500

apparmor (2.6.1-4ubuntu1) oneiric; urgency=low

  * Get rid of Perl in main AppArmor package so we can remove perl-modules
    from the installation cd:
    - debian/patches/0104-python-aa-status.patch: switch aa-status to
      Python
    - debian/apparmor.*, debian/apparmor-utils.*: move aa-status, symlink
      and manpages to main apparmor package.
    - debian/control: add appropriate Breaks/Replaces/Depends because of
      the file move, add ${python:Depends} to apparmor Depends, add
      apparmor-utils to apparmor Suggests.
    - debian/rules: add apparmor package to dh_python2.
  * debian/lib/apparmor/functions: fix hat separator (LP: #788616)
    - Based on upstream revision 1733

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 01 Jun 2011 11:03:20 -0400

apparmor (2.6.1-4) unstable; urgency=low

  * debian/po: add new translations:
    - zh_CN.po: Simplified Chinese, thanks to Aron Xu (Closes: 624853).
    - da.po: Danish, thanks to Joe Dalton (Closes: 625252).
    - sv.po: Swedish, thanks to Martin Bagge (Closes: 625264).
    - cs.po: Czech, thanks to Michal Šimůnek (Closes: 625465).
    - de.po: German, thanks to Chris Leick (Closes: 625931).
    - nl.po: Dutch, thanks to Jeroen Schot (Closes: 626269).
    - ja.po: Japanese, thanks to Hideki Yamane (Closes: 626803).
    - it.po: Italian, thanks to Dario Santamaria (Closes: 626836).
    - fr.po: French, thanks to Julien Patriarca (Closes: 626903).
    - es.po: Spanish, thanks to Francisco Javier Cuadrado (Closes: 627031).
  * debian/patches/define-path-max.patch: fix Hurd FTBFS.
  * debian/patches/indep-build.patch: allow split indep/arch builds.
  * debian/{control,rules,non-linux}: add fake parser for non-Linux
    builds so that apparmor-utils is installable (Closes: 625977).

 -- Kees Cook <kees@debian.org>  Fri, 27 May 2011 13:51:18 -0700

apparmor (2.6.1-3) unstable; urgency=low

  * debian/control: add sneaky missing Build-Dep on liblocale-gettext-perl
    (fixes FTBFS on some extremely minimal chroots, Closes: 624566).
  * debian/patches/0101-declarations.patch: add missing declarations needed
    for sensitive compilers (fixes FTBFS on mips/mipsel).
  * debian/patches/0102-manpage-release-name.patch: update manpage release
    names to match others.
  * debian/patches/0103-kfreebsd-compile.patch, debian/{control,rules}:
    attempt to build as much as possible (no parser) on non-Linux systems.
  * debian/po/ru.po: add translation, thanks to Yuri Kozlov (Closes: 624741).

 -- Kees Cook <kees@debian.org>  Sun, 01 May 2011 19:29:07 -0700

apparmor (2.6.1-2) unstable; urgency=low

  * debian/copyright: clarify for some full organization names.

 -- Kees Cook <kees@debian.org>  Wed, 27 Apr 2011 10:38:07 -0700

apparmor (2.6.1-1) unstable; urgency=low

  * Initial Debian upload (Closes: 622922).
  * debian/patches/0100-manpage-typo.patch: fix lintian error in manpage.
  * debian/clean: update for Debian build.
  * debian/copyright: rearrange and add a few missing files.
  * debian/source/format, debian/rules: convert to 3.0 quilt format.
  * debian/{rules,apparmor-profiles.postinst}: deal with lack of dh_apparmor.

 -- Kees Cook <kees@debian.org>  Sat, 23 Apr 2011 12:14:55 -0700

apparmor (2.6.1-0ubuntu3) natty; urgency=low

  * debian/patches/0003-add-debian-integration-to-lighttpd.patch: updates for
    lighttpd example profile to work in Debian/Ubuntu (LP: #582814)
  * debian/patches/0004-lp754889.patch: add several image viewers to
    ubuntu-browsers.d/multimedia abstraction (LP: #754889)


=== debian/control ===
Source: apparmor
Section: admin
Priority: extra
Maintainer: Kees Cook <kees@debian.org>
Build-Depends: debhelper (>= 8.1.2), flex, bison, bzip2, apache2-prefork-dev, libpam-dev, autotools-dev, libtool, automake, autoconf, chrpath, texlive-latex-base, swig, quilt, po-debconf, dejagnu, chrpath, python-all-dev, python, liblocale-gettext-perl
Build-Depends-Indep: perl (>= 5.8.0)
Standards-Version: 3.9.2
Homepage: http://apparmor.net/
Vcs-Bzr: https://code.launchpad.net/~kees/apparmor/debian

Package: apparmor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python:Depends}, lsb-base, initramfs-tools, debconf
Breaks: libapache2-mod-apparmor (<< 2.5.1-0ubuntu3), apparmor-utils (<< 2.6.1-4ubuntu1)
Replaces: apparmor-parser, libapache2-mod-apparmor (<< 2.5.1-0ubuntu3), apparmor-utils (<< 2.6.1-4ubuntu1)
Suggests: apparmor-profiles, apparmor-docs, apparmor-utils
Description: User-space parser utility for AppArmor
 This provides the system initialization scripts needed to use the
 AppArmor Mandatory Access Control system, including the AppArmor Parser
 which is required to convert AppArmor text profiles into machine-readable
 policies that are loaded into the kernel for use with the AppArmor Linux
 Security Module.

Package: apparmor-utils
Architecture: any
Depends: apparmor (>= 2.6.1-4ubuntu1), liblocale-gettext-perl, libterm-readkey-perl, librpc-xml-perl, libapparmor-perl, ${shlibs:Depends}, ${misc:Depends}, ${perl:Depends}
Suggests: apparmor-docs, libterm-readline-gnu-perl, vim-addon-manager
Description: Utilities for controlling AppArmor
 This provides the utilities to operate on AppArmor profiles, as well as
 the Perl modules needed for AppArmor audit log parsing. Profiles can be
 created, updated, enforced, set to complain mode, and disabled.

Package: apparmor-profiles
Architecture: all
Depends: ${misc:Depends}
Recommends: apparmor
Description: Profiles for AppArmor Security policies
 This provides various AppArmor profiles that have not been shipped by
 the packages they provide confinement for. By default, they ship in
 complain mode so that users can test and choose which are desired.

Package: apparmor-docs
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Documentation for AppArmor
 Thie provides some technical documentation for the AppArmor Mandatory
 Access Control system. Currently this is only a single PDF covering
 basic operation, written some time ago.

Package: libapparmor-dev
Section: libdevel
Architecture: any
Depends: libapparmor1 (= ${binary:Version}), ${misc:Depends}
Description: AppArmor development libraries and header files
 This package provides the develpment libraries and header files needed to
 link against the AppArmor changehat and log parsing functions. Also
 includes the manpages for library functions.

Package: libapparmor1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: changehat AppArmor library
 This package provides the shared library used for making use of the
 AppArmor profile and changehat functionality, as well as common log
 parsing routines.

Package: libapparmor-perl
Section: perl
Architecture: any
Depends: ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: AppArmor library Perl bindings
 This provides the Perl module that contains the language bindings
 for the AppArmor library, libapparmor, which were autogenerated via
 SWIG.

Package: libapache2-mod-apparmor
Section: libs
Architecture: any
Depends: apache2.2-common, ${shlibs:Depends}, ${misc:Depends}
Description: changehat AppArmor library as an Apache module
 This provides the Apache module needed to declare various differing
 confinement policies when running virtual hosts in the webserver
 by using the changehat abilities exposed through libapparmor.

Package: libpam-apparmor
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: changehat AppArmor library as a PAM module
 This provides the PAM module needed to declare various differing
 confinement policies when starting PAM sessions by using the
 changehat abilities exposed through libapparmor.

Package: apparmor-notify
Architecture: all
Depends: libapparmor-perl, libnotify-bin, ${perl:Depends}, ${misc:Depends}
Description: AppArmor notification system
 This package provides a utility to display AppArmor denial messages via
 desktop notifications. The utility can also be used to generate summary
 reports.

Package: python-libapparmor
Section: python
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
XS-Python-Version: ${python:Versions}
Description: AppArmor library Python bindings
 This provides the Python module that contains the language bindings
 for the AppArmor library, libapparmor, which were autogenerated via
 SWIG.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Uncomment to turn on verbose build-time test output
#export VERBOSE=1

# libapparmor uses autotools
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH_OS   ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

CONFFLAGS = --prefix=/usr --with-perl --with-python
ifeq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  CONFFLAGS += --build $(DEB_HOST_GNU_TYPE)
else
  CONFFLAGS += --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
endif

CFLAGS := -Wall -g
CXXFLAGS := -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
	CXXFLAGS += -O0
else
	CFLAGS += -O2
	CXXFLAGS += -O2
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	cd libraries/libapparmor && \
		sh autogen.sh && \
		sh configure $(CONFFLAGS)
	touch configure-stamp

build: build-stamp
build-stamp: configure-stamp
	dh_testdir
	cd libraries/libapparmor && $(MAKE) && $(MAKE) check
	cd utils && $(MAKE)
ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	cd parser && $(MAKE) indep
else
	cd parser && $(MAKE) && $(MAKE) check
endif
	cd profiles && $(MAKE)
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	for i in utils parser profiles changehat/mod_apparmor \
		  changehat/pam_apparmor ; do \
		[ ! -f $$i/Makefile ] || $(MAKE) -C $$i clean; \
		rm -f $$i/common; \
	done
	# Try to clean up from an autogen'd build
	cd libraries/libapparmor && [ ! -f Makefile ] || $(MAKE) distclean
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Utils
	cd utils; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    PERLDIR=$(CURDIR)/debian/tmp/usr/share/perl5/Immunix \
	    install

	# Parser
ifneq (,$(filter $(DEB_HOST_ARCH_OS), kfreebsd knetbsd hurd ))
	install -D -m 755 $(CURDIR)/debian/non-linux/apparmor_parser \
		$(CURDIR)/debian/tmp/sbin/apparmor_parser
	cd parser; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install-indep
else
	cd parser; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
endif

	# Changehat via libapparmor
	cd libraries/libapparmor; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# fixup rpath for libapparmor-perl
	find $(CURDIR)/debian/tmp/usr/lib/perl5 -name '*.so' | xargs chrpath --delete

	# Changehat via mod_apparmor
	cd changehat/mod_apparmor; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# Fix rpath in mod_apparmor.so
	chrpath -d $(CURDIR)/debian/tmp/usr/lib/apache2/modules/mod_apparmor.so

	# Changehat via libpam-apparmor
	cd changehat/pam_apparmor; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    install
	# Fix rpath in pam_apparmor.so
	chrpath -d $(CURDIR)/debian/tmp/lib/security/pam_apparmor.so

	# Profiles
	cd profiles; $(MAKE) \
	    DESTDIR=$(CURDIR)/debian/tmp \
	    EXTRAS_DEST=$(CURDIR)/debian/tmp/usr/share/doc/apparmor-profiles/extras \
	    install
	# set all profiles in apparmor-profiles to complain mode
	cd $(CURDIR)/debian/tmp && sh $(CURDIR)/debian/put-all-profiles-in-complain-mode.sh

	dh_install

# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs
	dh_installdocs
	dh_installexamples
#	dh_installmenu
	dh_installdebconf -papparmor
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
	dh_installinit --update-rcd-params='start 37 S .' --no-restart-on-upgrade --error-handler=true
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress -Xextras
	dh_fixperms
	dh_perl
	dh_python2 -p python-libapparmor -p apparmor --no-guessing-versions
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture independant packages using the common target.
binary-indep: build install
	for profile in $(shell grep ^etc/apparmor.d/ $(CURDIR)/debian/apparmor-profiles.install | \
			 cut -d/ -f3- | grep -v /); do \
	    if [ -x /usr/bin/dh_apparmor ]; then \
	        dh_apparmor --profile-name=$$profile -papparmor-profiles; \
	    fi; \
	done
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build install
	$(MAKE) -f debian/rules DH_OPTIONS=-s binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install configure

VERSION_SEP=+
VERSION=$(shell  dpkg-parsechangelog | grep ^Version | cut -d$(VERSION_SEP) -f1 | cut -d\  -f2)
BZR_RELEASE=$(shell dpkg-parsechangelog | grep ^Version | cut -d$(VERSION_SEP) -f2 | cut -d. -f1 | cut -d- -f1 | sed -e 's/bzr//')
ORIG_FILE=$(CURDIR)/../apparmor_$(VERSION)$(VERSION_SEP)bzr$(BZR_RELEASE).orig.tar.gz
BZR_CO_DIR=$(CURDIR)/apparmor-$(VERSION)$(VERSION_SEP)bzr$(BZR_RELEASE)
get-orig-source:
	test ! -e $(ORIG_FILE)
	test ! -e $(BZR_CO_DIR)
	bzr checkout --lightweight -r $(BZR_RELEASE) lp:~apparmor-dev/apparmor/master $(BZR_CO_DIR)
	tar czf $(ORIG_FILE) -C `dirname $(BZR_CO_DIR)` --exclude .bzr `basename $(BZR_CO_DIR)`
	rm -rf $(BZR_CO_DIR)
